<template>
  <fieldset
    role="radiogroup"
    class="ui-radio-group group flex flex-col text-base lg:text-lg xl:text-xl [&_.ui-form-hints_.hints]:mb-1"
    v-bind="filteredAttrs"
    :class="[
      {
        '[&_.ui-form-hints_.hints]:text-gray-400': disabled,
        'contents [&_.ui-form-errors]:col-span-full [&_.ui-form-errors]:place-self-stretch [&_.ui-form-errors_.errors]:rounded-none [&_.ui-form-errors_.errors]:border-0 [&_.ui-form-errors_.errors]:py-1':
          isGridChild,
        '[&:not(:last-child)_.ui-form-errors]:border-b [&:not(:last-child)_.ui-form-errors]:border-b-gray-300':
          isGridChild && !hasErrors,
        '[&_.ui-form-errors]:-ml-3 [&_.ui-form-errors]:mb-2 [&_.ui-form-errors]:border-b-4 [&_.ui-form-errors]:border-l-4 [&_.ui-form-errors]:border-red-600':
          isGridChild && hasErrors,
        '[&_.ui-form-errors_.errors]:mt-4': !isGridChild,
        'has-errors': hasErrors,
      },
      $attrs.class as string,
    ]"
    :style="$attrs.style"
    :aria-describedby="`${hintsId} ${errorsId}`"
    :aria-required="required"
  >
    <legend :aria-labelledby="legendId" class="sr-only"></legend>
    <div
      :class="{
        'z-10 flex w-full justify-between gap-1 bg-[linear-gradient(to_bottom,transparent,transparent_0.2rem,theme(colors.gray.200)_0.2rem,theme(colors.gray.200)_0.4rem)] bg-[left_0.5em] bg-no-repeat motion-safe:transition-[background-size]':
          hasResetButton && !isGridChild,
        'bg-[size:0%_0.4rem]': !resetButtonIsVisible,
        'bg-[size:100%_0.4rem]': resetButtonIsVisible,
        contents: isGridChild,
      }"
    >
      <div :id="legendId" :class="{ 'place-self-start': isGridChild }">
        <slot :label="label" :required="required" name="label">
          <div
            class="inline-block leading-relaxed motion-safe:transition-colors"
            :class="{
              'py-3': isGridChild,
              'font-medium group-focus-within:text-violet-700': !hasErrors,
              'font-bold text-red-600 group-focus-within:text-red-700':
                hasErrors,
              '-ml-3 border-l-4 border-l-red-600 pl-2':
                isGridChild && hasErrors,
            }"
          >
            <span
              :class="{
                'bg-white box-decoration-clone pr-2': hasResetButton,
              }"
            >
              <span
                v-if="highlighted"
                aria-hidden="true"
                class="-ml-6 -mt-1 inline-block h-0 w-8 overflow-visible align-top text-2xl motion-safe:-ml-8 motion-safe:animate-point-right md:-ml-12 md:w-12 md:text-3xl"
                >👉</span
              >{{ label
              }}<span aria-hidden="true">{{ required ? '*' : '' }}</span>
            </span>
          </div>
        </slot>
      </div>
      <button
        v-if="hasResetButton && !isGridChild"
        type="button"
        class="-mt-3 flex size-12 shrink-0 rotate-[30deg] select-none items-center justify-center rounded-full border-[3px] border-transparent bg-white text-2xl font-bold text-gray-600 outline-none ring-2 ring-white duration-300 hover:rotate-[-330deg] hover:bg-violet-100 hover:text-violet-700 focus:rotate-[-330deg] focus:border-violet-600 focus:bg-violet-100 focus:text-violet-700 motion-safe:transition-[opacity,transform]"
        :title="resetButtonLabel"
        :disabled="!resetButtonIsVisible"
        :class="{
          'opacity-0': !resetButtonIsVisible,
        }"
        @click="onChange(undefined)"
      >
        <span aria-hidden="true">↺</span>
      </button>
    </div>
    <slot :hints-id="hintsId" :hints="mergedHints" name="hints">
      <ui-form-hints
        :hints-id="hintsId"
        :hints="mergedHints"
        :class="{ 'sr-only': isGridChild }"
      />
    </slot>
    <div
      class="mt-2 border-l-4 pl-2 motion-safe:transition-all"
      :class="{
        'space-y-4': !isGridChild,
        contents: isGridChild,
        'border-transparent': !hasErrors,
        'border-red-600': hasErrors,
        '-ml-3': buttons && !hasErrors,
        'ml-0': buttons && hasErrors,
      }"
    >
      <slot
        :disabled="disabled"
        :invalid="hasErrors"
        :options="options"
        :native-name="inputId"
        :button="buttons"
      >
        <ui-radio
          v-for="(option, index) of options"
          :key="getOptionKey(option, index)"
          :model-value="modelValue"
          :value="getOptionValue(option)"
          :name="inputId"
          :button="buttons"
          :disabled="
            disabled || (typeof option === 'object' && option.disabled)
          "
          :tabindex="index === 0 && modelValue === undefined ? 0 : undefined"
          :labelled-by-id="
            typeof option === 'object' ? option?.labelledById : undefined
          "
          @update:model-value="onChange"
        >
          {{
            typeof option !== 'object'
              ? option
              : option.label ?? option.id ?? option
          }}
        </ui-radio>
        <button
          v-if="hasResetButton && isGridChild"
          type="button"
          class="m-0 flex size-12 shrink-0 rotate-[30deg] select-none items-center justify-center rounded-full border-[3px] border-transparent bg-white text-2xl font-bold text-gray-600 outline-none duration-300 hover:rotate-[-330deg] hover:bg-violet-100 hover:text-violet-700 focus:rotate-[-330deg] focus:border-violet-600 focus:bg-violet-100 focus:text-violet-700 motion-safe:transition-transform"
          :title="resetButtonLabel"
          :disabled="!resetButtonIsVisible"
          :class="{
            'opacity-0': !resetButtonIsVisible,
          }"
          @click="onChange(undefined)"
        >
          <span aria-hidden="true">↺</span>
        </button>
      </slot>
    </div>
    <slot :errors-id="errorsId" :errors="parsedErrors" name="errors">
      <ui-form-errors :errors-id="errorsId" :errors="parsedErrors" />
    </slot>
  </fieldset>
</template>

<script lang="ts" setup>
import { computed, useAttrs, PropType } from 'vue'
import { useFormElementErrors, useFormElementId } from '../../composables'
import { RadioGroupOption } from '../../propInterfaces'
import UiRadio from './Radio.vue'
import UiFormHints from './FormHints.vue'
import UiFormErrors from './FormErrors.vue'

defineOptions({
  name: 'UiRadioGroup',
  inheritAttrs: false,
})

const props = defineProps({
  disabled: {
    type: Boolean,
    default: false,
  },
  hints: {
    type: [String, Array] as PropType<string | string[]>,
    default: () => [],
  },
  label: {
    type: String,
    default: undefined,
  },
  name: {
    type: String,
    default: '',
  },
  required: {
    type: Boolean,
    default: false,
  },
  highlighted: {
    type: Boolean,
    default: false,
  },
  highlightedHint: {
    type: String,
    default: '',
  },
  modelValue: {
    type: [String, Number, Boolean],
    default: undefined,
  },
  options: {
    type: Array as PropType<(string | number | boolean | RadioGroupOption)[]>,
    default: () => [],
    validate: (array: RadioGroupOption[]) =>
      array.every((option) =>
        typeof option === 'object'
          ? option.id !== undefined &&
            option.id !== null &&
            option.label !== undefined &&
            option.label !== null
          : option !== undefined && option !== null,
      ),
  },
  buttons: {
    type: Boolean,
    default: false,
  },
  errors: {
    type: [String, Array, Boolean] as PropType<string | string[] | boolean>,
    default: () => [],
  },
  touched: {
    type: Boolean,
    default: undefined,
  },
  setTouched: {
    type: Function as PropType<(touched: boolean) => void>,
    default: undefined,
  },
  isResettable: {
    type: Boolean,
    default: false,
  },
  resetButtonLabel: {
    type: String,
    default: 'Reset selection',
  },
  isGridChild: {
    type: Boolean,
    default: false,
  },
})

const filteredAttrs = computed(() => {
  const { class: _, style, onBlur, ...filteredAttrs } = useAttrs()
  return {
    ...filteredAttrs,
    onBlurCapture: ($event: FocusEvent) => {
      typeof props.setTouched === 'function' && props.setTouched(true) // vee-validate blur handler
      typeof onBlur === 'function' && onBlur($event) // native blur handler
    },
  }
})

const emit = defineEmits(['update:modelValue'])

const onChange = ($event?: Event) => emit('update:modelValue', $event)

const mergedHints = computed(() => [
  ...(props.highlightedHint ? [props.highlightedHint] : []),
  ...(Array.isArray(props.hints) ? props.hints : [props.hints]),
])

const { uniqueId, errorsId, hintsId, legendId } = useFormElementId(props)

const inputId = computed(() => props.name || uniqueId)

const { hasErrors, parsedErrors } = useFormElementErrors(props)

const hasResetButton = computed(
  () => props.isResettable && !props.required && !props.disabled,
)

const resetButtonIsVisible = computed(
  () => hasResetButton.value && props.modelValue !== undefined,
)

const getOptionKey = (
  option: string | number | boolean | RadioGroupOption,
  index: number,
) => {
  const key =
    typeof option !== 'object' ? option : option.id ?? option.label ?? index

  if (typeof key === 'boolean') {
    return `bool-${key}`
  }

  return key
}

const getOptionValue = (
  option: string | number | boolean | RadioGroupOption,
) => {
  return typeof option === 'object' ? option.id : option
}
</script>
